<?php
/*!*******************************************************************************
*! FILE NAME  : ping.php
*! DESCRIPTION: returns first value in selected /proc/stat output
*!  (to see if camera was rebooted)
*! Copyright (C) 2010 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*/
  $field='btime';
  if (count($_GET)>0) {
    $field=key($_GET); 
  }
  exec('cat /proc/stat',$data);
  $value=0;
  foreach ($data as $line) {
   $aline=explode(' ',$line);
   if ((count($aline)>1) && ($aline[0]==$field)) {
     $value=$aline[1]+0;
     break;
   }
  }
  $xml = new SimpleXMLElement("<?xml version='1.0'?><ping/>");
  $xml->addChild ($field,$value);
  $rslt=$xml->asXML();
  header("Content-Type: text/xml");
  header("Content-Length: ".strlen($rslt)."\n");
  header("Pragma: no-cache\n");
  printf($rslt);
?>

