<?
//exec("ps -w", $arr1);
exec("top -n 1", $arr2);
?>
<h1>Process Manager</h1>
<fieldset style="width:600px;">
<?
echo "<pre>";
echo substr($arr2[0], 6)."<br>";
echo $arr2[1]."<br>";
echo $arr2[2]."";
echo "</pre>";
?>
<table border="0" cellpadding="5px" cellspacing="0px" width="100%">
<tr><td width="280px"><b>Process</b></td><b width="100px"><b>Memory</b></td><td width="100px"><b>CPU</b></td></tr>
<?
$i=4;
while ($arr2[$i] != null) {
	$line = $arr2[$i];
	while(strstr($line, "  ")) {
		$line = str_replace("  ", " ", $line);
		while ($line[0] == " ")
			$line = substr($line, 1);
	}
	$value = explode(" ", $line);
	if ($i%2 == 0)
		echo "<tr style=\"background-color:#ddd;\">";
	else
		echo "<tr style=\"background-color:#eee;\">";

	switch($value[7]) {
		case "/usr/local/bin/str":
			$name = "<b>Streamer</b><br><span class=\"notice\">".$value[7]."</span>";
			break;
		case "/usr/local/sbin/php":
			$name = "<b>PHP</b><br><span class=\"notice\">".$value[7]."</span>";
			break;
		case "/usr/local/sbin/lighttpd":
			$name = "<b>Lighttpd Webserver</b><br><span class=\"notice\">".$value[7]."</span>";
			break;		
		case "/usr/local/sbin/autoexposure":
			$name = "<b>Autoexposure Deamon</b><br><span class=\"notice\">".$value[7]."</span>";
			break;
		case "/bin/vftpd":
			$name = "<b>FTP Server</b><br><span class=\"notice\">".$value[7]."</span>";
			break;
		case "/usr/sbin/syslogd":
			$name = "<b>Linux System Logging Utitliy</b><br><span class=\"notice\">".$value[7]."</span>";
			break;
		case "/usr/sbin/klogd":
			$name = "<b>Linux Kernel Logging Utitliy</b><br><span class=\"notice\">".$value[7]."</span>";
			break;
		case "/usr/local/sbin/imgsrv":
			$name = "<b>Elphel Image Server</b><br><span class=\"notice\">".$value[7]."</span>";
			break;
		case "/sbin/respawnd":
			$name = "<b>Respawning Daemon</b><br><span class=\"notice\">".$value[7]."</span>";
			break;
		case "init":
			$name = "<b>Startup Script</b><br><span class=\"notice\">".$value[7]."</span>";
			break;
		case "top":
			$name = "<b>Process Manager</b><br><span class=\"notice\">".$value[7]."</span>";
			break;
		case "/bin/utelnetd":
			$name = "<b>Telnet Server Daemon</b><br><span class=\"notice\">".$value[7]."</span>";
			break;

		default: 
			$name = $value[7]; 
			break;
	}
	echo "<td>".$name."</td>";
	echo "<td>".$value[5]."</td>";
	echo "<td>".$value[6]."</td>";
	echo "</tr>";
	
	$i++;
}
?>
</table>
</fieldset>
<p><b>Notes: </b></p>
<span class="notice">
<b>Why can the total memory exceed 100%?</b><br>
<p style="width:600px;">There is memory mapped (mmap) access to shared areas in the driver and applications on the camera - it is the fastest communication that avoids extra copying. Basically just an area of the driver space is shown to application "as if" it is somewhere in the application's space. That is how most of the data arrays are visible by the PHP extension - the largest one is a 19MB circular buffer.</p>
<p style="width:600px;">In the streamer this space is even mapped twice, as the buffer is circular some frames can start at the end of the buffer and continue at the beginning. So each frame is continuous (it always starts in the lowest of those two "copies" of the mmapped array and ends either in the same one, or - in the next copy.</p>
<b>Why do some processes like PHP have multiple instances?</b><br>
<p style="width:600px;">Simply to increase performance and avoid forking each time on a http request.</p>
</span>


