<?
$s = exec("/bin/bootblocktool -x SERNO");
exec('dmesg', $arr1);
$dmesg = implode("\n", $arr1);

// detect IO Boards
require 'i2c.inc';

$error = false;
$found_10369 = false;
$found_10359 = false;

$rslt = i2c_read256b();
$zero = strpos($rslt,chr(0));
if ($zero!==false) 
	$rslt=substr($rslt,0, $zero);
if (substr($rslt,0,5) != "<?xml") {
	$error = true; /// wrong responce (non existent/ not programmed boards?)
}
$xml = simplexml_load_string($rslt);

if (!$error) {
	if (strstr($xml->model, "10369"))
		$found_10369 = true;
}

$bdetect_log="/var/log/bdetect";
if(is_file($bdetect_log)) {
	if (file_get_contents("/var/log/bdetect") == "10359") 
		$found_10359 = true;
}
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<meta http-equiv="content-type" content="text/html; charset=UTF-8">
	<link href="setup.css" rel="stylesheet" type="text/css" media="screen">
	<title>System Preferences</title>
</head>
<body>
	<div id="menu">
    	<div id="menu_header"></div>
    	<div class="menu_item"><a href="?page=network">Network Settings</a></div>
        <div class="menu_item"><a href="?page=firmware">Firmware</a></div>
        <div class="menu_item"><a href="?page=report">Status Report</a></div>
        <div class="menu_item"><a href="?page=date">Time &amp; Date</a></div>
        <div class="menu_item"><a href="?page=daemons">Autostart Daemons</a></div>
		<div class="menu_item"><a href="?page=ps">Process Manager</a></div>
        <div class="menu_item"><a href="?page=netstat">Network Connections</a></div>       
        <br>
        <div class="menu_item_header">Boards:</div> <!-- BOARD DETECTION -->
            <div class="menu_item detected"><a href="?page=10353">10353</a> <img src="images/check.gif"></div>
            <? 
            if ($found_10369)
                echo "<div class=\"menu_item detected\"><a href=\"?page=10369\">10369</a> <img src=\"images/check.gif\"></div>";
            else
                echo "<div class=\"menu_item notdetected\">10369</div>";
                
            if ($found_10359)
                echo "<div class=\"menu_item detected\"><a href=\"?page=10359\">10359</a> <img src=\"images/check.gif\"></div>";
            else
                echo "<div class=\"menu_item notdetected\">10359</div>";
            ?>
    </div>
<div id="content">
    <?
	switch($_GET['page']) {
		case "network":
			include("network.php");
			break;
		case "report":
			include("report.php");
			break;
		case "date":
			include("date.php");
			break;	
		case "firmware":
			include("firmware.php");
			break;	
		case "ps":
			include("ps.php");
			break;				
		case "daemons":
			include("daemons.php");
			break;										
		case "10369":
			include("10369.php");
			break;
		case "10353":
			include("10353.php");
			break;
		case "10359":
			include("10359.php");
			break;			
		case "netstat":
			include("netstat.php");
			break;				
		default:
			include("network.php");
			break;
	}
	
	?>
    </div>
</body>
</html>
