<?
/*!***************************************************************************
*! FILE NAME  : buffer_monitor.php
*! DESCRIPTION: buffer_monitor application launcher
*! AUTHOR     : Oleg K Dzhimiev <oleg@elphel.com>
*! Copyright (C) 2010 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: buffer_monitor.php,v $
*!  Revision 1.1  2010/09/12 02:02:28  dzhimiev
*!  initial version
*!
*!  
*/

$recs=1000;    //number of records in the log file
$qctrl=0;      //compression quality control enable: 0/1
$qgoal=98;     //compression quality goal, %
$fmax=5500000; //maximum image size in Bytes
$fmin=500000;  //minimum image size in Bytes
$dbglvl=1;     //debug level: 0/1 - 0 - no messages
$log="/usr/html/var/buffer_monitor.log"; //log file full path

$start=false;
$stop=false;

foreach($_GET as $key=>$value) {
	switch($key) {
		case "recs"  : $recs = $value+0; break;
		case "qctrl" : $qctrl = $value+0; break;
		case "qgoal" : $qgoal = $value+0; break;
		case "fmax"  : $fmax = $value+0; break;
		case "fmin"  : $fmin = $value+0; break;
		case "dbglvl": $dbglvl = $value+0; break;
		case "log"   : $log = $value; break;

		case "start" : $start=true; break;
		case "stop" : $stop=true; break;
	}
}

if ($start) exec("buffer_monitor $recs $qctrl $qgoal $fmax $fmin $dbglvl $log &");
if ($stop)  exec("killall buffer_monitor");

?>

