#include <netinet/ip.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <linux/if_ether.h>
#include <sys/ioctl.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/param.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <net/if.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <linux/if_ether.h>
#include <poll.h>

#include <map>
#include <set>
#include <iostream>

using namespace std;

unsigned long port_out = 40000;
unsigned long port_in = 40001;

int signal_recv(set<unsigned long> ports) {
//int signal_recv(unsigned long port) {
	int nfds = ports.size();
	struct pollfd *fds = (struct pollfd*)malloc(sizeof(struct pollfd) * nfds);
	int i = 0;
	struct sockaddr_in addr;
	memset(&addr, 0, sizeof(struct sockaddr_in));
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = INADDR_ANY;
	int zu = 1;
	unsigned long buf[3];
	for(set<unsigned long>::iterator it = ports.begin(); it != ports.end(); it++, i++) {
//		cout << "port: " << *it << endl;
		int s = socket(PF_INET, SOCK_DGRAM, 0);
		fds[i].fd = s;
		fds[i].events = POLLIN;
		fds[i].revents = 0;
		addr.sin_port = htons(*it);
		setsockopt(s, SOL_SOCKET, SO_BROADCAST, &zu, sizeof(zu));
		bind(s, (struct sockaddr *)&addr, sizeof(struct sockaddr_in));
	}
	int c = nfds;
	while(c != 0) {
		poll(fds, nfds, 0);
		for(i = 0; i < nfds; i++) {
			if(fds[i].revents |= POLLIN) {
				fds[i].events = 0;
				fds[i].revents = 0;
				int z = recv(fds[i].fd, (void *)&buf[0], 12, 0);
				char b[256];
				sprintf(b, "Magic: 0x%08X, ID: 0x%08X, count: 0x%08X", htonl(buf[0]), htonl(buf[1]), htonl(buf[2]));
				cerr << "Accept signal with length: " << z << " and data: " << b << endl;
				c--;
			}
		}
	}
	free(fds);
	return 0;
}

int signal_send(unsigned long port) {
	int s = socket(PF_INET, SOCK_DGRAM, 0);
	struct sockaddr_in addr;

	memset(&addr, 0, sizeof(struct sockaddr_in));
	addr.sin_family = AF_INET;
	addr.sin_port = htons(port);
//	addr.sin_addr.s_addr = INADDR_BROADCAST;
	addr.sin_addr.s_addr = inet_addr("192.168.0.15");
	int zu = 1;
	setsockopt(s, SOL_SOCKET, SO_BROADCAST, &zu, sizeof(zu));
	// make bind to real ethernet interface, to send packets to correct iface
	bind(s, (struct sockaddr*)&addr, sizeof(struct sockaddr_in));

	memset(&addr, 0, sizeof(struct sockaddr_in));
	addr.sin_family = AF_INET;
	addr.sin_port = htons(port);
	addr.sin_addr.s_addr = INADDR_BROADCAST;
//	addr.sin_addr.s_addr = inet_addr("192.168.0.10");
	zu = 1;
	setsockopt(s, SOL_SOCKET, SO_BROADCAST, &zu, sizeof(zu));
	connect(s, (struct sockaddr*)&addr, sizeof(struct sockaddr_in));

//	char data[] = {0x01};
	unsigned long data[3];
//	data[0] = 0x5452472D;
	data[0] = 0x2D475254;
	data[1] = htonl(0x00001000);
	data[2] = htonl(1);
//	send(s, (void *)&data[0], 12, 0);
	send(s, (void *)&data[0], 12, 0);
	close(s);
	return 0;
}

int main(int argc, char *argv[]) {
	cout << "options: [-in port_1[,port_2[,...]]] [-out port_out]; receive signals READY from -in ports, by default " << port_in
		<< " and send broadcast pulse to port -out, by default " << port_out << endl;
//	signal_recv(port_in);
//	usleep(5000); // wait before send trigger pulse, because with 6.3.3 firmware camera can lost responce

	string opt;
	map<string, string> args;
	for(int i = 1; i < argc; i++) {
		if(argv[i][0] == '-' && argv[i][1] != '\0') {
			if(opt != "")
				args[opt] = "";
			opt = &argv[i][1];
			continue;
		} else {
			if(opt != "") {
				args[opt] = argv[i];
				opt = "";
			}
		}
	}
	if(opt != "")
		args[opt] = "";
//	for(map<string, string>::iterator it = args.begin(); it != args.end(); it++) {
//		cerr << "|" << (*it).first << "| == |" << (*it).second << "|" << endl;
//	}

	set<unsigned long> ports_in;
	string in;
	if((in = args["in"]) != "") {
		in += ",";
		const char *c = in.c_str();
//		cout << "in == |" << in << "|" << endl;
		for(int i = 0; c[i]; i++) {
			string n = "";
			for(; c[i] != ','; i++)
				n += c[i];
			ports_in.insert(atol(n.c_str()));
			
		}
	} else
		ports_in.insert(port_in);
	if(args["out"] != "")
		port_out = atol(args["out"].c_str());

	signal_recv(ports_in);
	signal_send(port_out);
	return 0;
}
