#!/bin/sh
. /etc/init.d/functions.sh
begin "Flushing JFFS2 (sync)" ; sync ; end $?
begin "Starting autocampars daemon" ;
  /usr/local/sbin/autocampars & >/dev/null
end $?

begin "Starting autoexposure daemon"
  /usr/local/sbin/autoexposure & >/dev/null
end $?

begin "Starting ccamftp daemon"
#DAEMON_BIT_CCAMFTP      2
  /usr/local/sbin/launch_php_script 2 /usr/local/sbin/ccamftp.php & >/dev/null
end $?
# Streamer should probably be after USB for audio?
#  echo "starting streamer: /usr/local/bin/str &"
#  /usr/local/bin/str &
begin "initializing camera/sensor parameters"
#  /usr/html/autocampars.php --init >/var/log/autocampars_boot.log
  /usr/html/autocampars.php --init --ignore-revision >/var/log/autocampars_boot.log # otherwise autocampars silently fails at boot time (only one "fail" in dmesg) if rev changed

end $?
exit 0 
