#!/usr/local/sbin/php -q
<?php
/*!
*! PHP script
*! FILE NAME  : detect_ioboard.php
*! DESCRIPTION: detect extension board/revision (to be called from the command line)
*! AUTHOR     : Elphel, Inc.
*! Copyright (C) 2008 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: detect_ioboard.php,v $
*!  Revision 1.1.1.1  2008/11/27 20:04:03  elphel
*!
*!
*!  Revision 1.1  2008/09/22 22:55:50  elphel
*!  snapshot
*!
*/
require 'i2c.inc';
        $rslt=i2c_read256b();
        $zero=strpos($rslt,chr(0));
        if ($zero!==false) $rslt=substr($rslt,0, $zero);
        if (substr($rslt,0,5)!="<?xml") {
         exit (1); /// wrong responce (non existent/ not programmed boards?)
        }
        $xml=simplexml_load_string($rslt);
        if ($_SERVER['argc']<2)  {
          echo strtoupper($xml->model.$xml->rev);
          exit (0);
        }
        if ($xml->model != $_SERVER['argv'][1]) {
          exit (2); /// wrong model
        }
        echo strtoupper($xml->rev);
        exit (0);
?>
