<?php
/*!***************************************************************************
*! FILE NAME  : preset.php
*! DESCRIPTION: Preset Browser
*! Copyright (C) 2009 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: preset.php,v $
*!  Revision 1.2  2009/03/17 22:04:56  oneartplease
*!  presets can now be viewed and edited
*!
*!  loading presets works with sensor window settings only at the moment
*!
*!  some 8.0 adaptions
*!
*!  Revision 1.1  2009/01/14 08:17:12  oneartplease
*!  version 0.1 of the preset manager
*!
*!
*!  Revision 1.0  2009/01/03 Sebastian Pichelhofer
*!  initial revision with basic interface
*!
*/
	$reload = false;
	// save the "Prompt for filename after recording" checkbox state in a cookie
	if (isset($_POST['settings_format']))
	{
		setcookie("prompt_filename", $_POST['prompt_filename'], time()+3600*24*7);
		$prompt_filename = $_POST['prompt_filename'];
	}
	else
	{
		$prompt_filename = $_COOKIE['prompt_filename'];
	}
	 	
	/*
		require_once('xml_simple.php');
		function parse_array($element) 
		{
		    global $logdata, $logindex;
		    foreach ($element as $header => $value) 
			{
		        if (is_array($value)) 
				{
		            parse_array($value);
		            $logindex++;
		        } else 
				{
		            $logdata[$logindex][$header] = $value;
		        }
		    }
		}
	
		$parser =& new xml_simple('UTF-8');
		$request = $parser->parse($xml_status);
	
		// catch errors
		$error_code = 0;
		if (!$request) {
		    $error_code = 1;
		    echo("XML error: ".$parser->error);
		}
	
		$logdata = array();
		$logindex = 0;
		parse_array($parser->tree);
		
		// load xml tags
		$xml_format = substr($logdata[0]['format'], 1, strlen($logdata[0]['format'])-2);
		$xml_state = substr($logdata[0]['state'], 1, strlen($logdata[0]['state'])-2);
		$xml_directory = substr($logdata[0]['prefix'], 1, strlen($logdata[0]['prefix'])-2);
		$xml_compressor_state = substr($logdata[0]['compressor_state'], 1, strlen($logdata[0]['compressor_state'])-2);
		$xml_file_length = substr($logdata[0]['file_length'], 0, strlen($logdata[0]['file_length'])); // file size in bytes
		$xml_file_duration = substr($logdata[0]['file_duration'], 0, strlen($logdata[0]['file_duration']));
		$xml_frame_number = substr($logdata[0]['frame_number'], 0, strlen($logdata[0]['frame_number']));
		$xml_res_x = substr($logdata[0]['frame_width'], 0, strlen($logdata[0]['frame_width']));
		$xml_res_y = substr($logdata[0]['frame_height'], 0, strlen($logdata[0]['frame_height']));
		
		
		//advanced settings
		$xml_timescale = substr($logdata[0]['timescale'], 0, strlen($logdata[0]['timescale']));
		$xml_frameskip = substr($logdata[0]['frames_skip'], 0, strlen($logdata[0]['frames_skip']));
		$xml_timelapse = substr($logdata[0]['seconds_skip'], 0, strlen($logdata[0]['seconds_skip']));
		$xml_exif = substr($logdata[0]['exif'], 0, strlen($logdata[0]['exif']));
		$xml_split_size = substr($logdata[0]['max_length'], 0, strlen($logdata[0]['max_length']));
		$xml_split_length = substr($logdata[0]['max_duration'], 0, strlen($logdata[0]['max_duration']));
		
		*/
	
	// GUI
	?>
	<html>
	<head>
    <title>Preset Browser</title>
	<link href="preset.css" rel="stylesheet" type="text/css" media="screen">
    <link href="SpryTabbedPanels.css" rel="stylesheet" type="text/css">
	<link href="SpryCollapsiblePanel.css" rel="stylesheet" type="text/css">

	<script src="preset.js" type="text/javascript"></script>    
    <script src="SpryTabbedPanels.js" type="text/javascript"></script>
	<script src="SpryCollapsiblePanel.js" type="text/javascript"></script>

	</head>
	<body onLoad="init();">
    <div id="sitecoloumn">
      <div id="live-image">
        <div id="CollapsiblePanel1" class="CollapsiblePanel">
          <div class="CollapsiblePanelTab" tabindex="0">Live-Preview</div>
          <div id="CollapsiblePanel1Inhalt" class="CollapsiblePanelContent">
			<div id="live-image-header">
            	<table border="0" cellpadding="2" cellspacing="0">
                    <tr>
	                    <td width="245px"></td>
                        <td width="100px"><a href="#" onClick="update_live_image();">Update</a></td>
                        <td width="100px">Size: <a href="#" onClick="size_up_image()">+</a> | <a href="#" onClick="size_down_image()">-</a></td>
                        <td width="300px"><input type="checkbox" onChange="live_image_auto_update_changed();" id="live_image_auto_update" value="yes" name="live_image_auto_update" style="top:3px; position:relative;"> Auto Update every: <input id="live_image_auto_update_frequency" type="text" name="live_image_auto_update_frequency" value="5.0" size="3" onChange="validate_update_freq();" style=" top:1px; position:relative; height:18px; font-size:7px; margin:0px; padding:0px;"> seconds</td> 
                    </tr>
                </table>
        	</div>
        	<img id="live-picture" style="border:solid 1px #000; margin:3px;" src="http://<? echo $_SERVER['SERVER_NAME']; ?>:8081/bimg" width="400" height="300"><br>
		  </div>
        </div>
    </div>
       	
        <div id="header">Preset Browser</div>
        <table border="0" cellpadding="2" cellspacing="5">
        <tr><td>
        <div id="files">
            <div id="files_header">
            	device: <span id="mounted_devices">loading ...</span><br>
            	<div id="file_browser_commands">
                <table cellpadding="0" cellspacing="0" border="0">
                <tr>
                	<td width="80"><a href="#" id="refresh_file_list" title="refresh the filebrowser" onClick='list_files(getCookie("preset_current_dir"));'><img src="images/reload.png" style="bottom:-2px; position:relative;"> reload</a></td>
               	  <td width="105"><a href="#" id="mount_hdd_button" onClick="mount_hdd();"> mount</a>
                  <a href="#" id="create_folder" onClick="create_folder();"><img src="images/create_folder.png" title="create a new folder in the currently open directory below" style="bottom:-3px; position:relative;"> create folder</a></td>
               	  <td width="115"><a href="#" id="create_webshare_button" onClick="create_webshare();"> create webshare</a>
                  <a href="#" id="set_rec_dir" onClick="set_rec_dir();" title="set the currently open directory below as the target folder for recording video files"><img src="images/rec_folder.png" style="bottom:-3px; position:relative;"> set target folder</a></td>
                </tr>
                </table>
            	</div>
       	  </div>
            <span id="filelist">nothing mounted.</span><br>
            <div id="files_footer">remaining free space: <span id="hdd_rem">loading ...</span><span id="files_current_folder">loading...</span></div>
      	</div>
        </td>
        <td valign="top">
        <div id="TabbedPanels1" class="TabbedPanels">
          <ul class="TabbedPanelsTabGroup">
		    <li class="TabbedPanelsTab" tabindex="0">Parameters</li>
            <li class="TabbedPanelsTab" tabindex="1">Auto Save</li>
              <li class="TabbedPanelsTab" tabindex="2">Preferences</li>
              <li class="TabbedPanelsTab" tabindex="3">Advanced</li>
          </ul>
          <div class="TabbedPanelsContentGroup">
            <div class="TabbedPanelsContent">
            <!-- Parameters -->
            
            <table class="parameter_table" border="0px" cellpadding="0px" cellspacing="0px">
            	<tr><td colspan="3"><input type="button" value="update" id="update" onClick="update_parameters();" /></td><td colspan="4"><input type="checkbox" name="autoupdate" style="top:3px; position:relative" /> Auto Update every <input id="parameter_auto_update_frequency" type="text" name="parameter_auto_update_frequency" value="5.0" size="3" onChange="validate_update_freq();" style=" top:0px; position:relative; height:18px; font-size:9px; margin:0px; padding:0px;"> seconds</td></tr>
                <tr><td>&nbsp;</td></tr>
            </table>
            <table class="parameter_table" border="0px" cellpadding="0px" cellspacing="0px">
                <tr><td colspan="6" >Sensor Window:</td><td colspan="3" >Binning:</td><td colspan="3" >Decimation:</td></tr>
                <tr>
                    <td width="10px"><input type="checkbox" name="woi_left" id="woi_left" /></td>
                    <td width="30px"><b>Left:</b> </td>
                    <td width="30px" id="ajax_woi_left"><? echo elphel_get_P_value(ELPHEL_WOI_LEFT); ?></td>
                    <td width="10px"><input type="checkbox" name="woi_width" id="woi_width" /></td>
                    <td width="30px"><b>Width:</b> </td>
                    <td width="50px" id="ajax_woi_width"><? echo elphel_get_P_value(ELPHEL_WOI_WIDTH); ?></td>
                    <td width="10px"><input type="checkbox" name="binning_hor" id="binning_hor" /></td>
                    <td width="10px"><b>X:</b> </td>
                    <td width="10px" id="ajax_binning_hor"><? echo "1:".elphel_get_P_value(ELPHEL_BIN_HOR); ?></td>
                    <td width="10px"><input type="checkbox" name="dec_hor" id="dec_hor" /></td>
                    <td width="10px"><b>X:</b> </td>
                    <td width="10px" id="ajax_dec_hor"><? echo "1:".elphel_get_P_value(ELPHEL_DCM_HOR); ?></td>
                </tr>
                <tr>
                    <td><input type="checkbox" name="woi_top" id="woi_top" /></td>
                    <td><b>Top:</b> </td>
                    <td id="ajax_woi_top"><? echo elphel_get_P_value(ELPHEL_WOI_TOP); ?></td>
                    <td><input type="checkbox" name="woi_height" id="woi_height" /></td>
                    <td><b>Height:</b> </td>
                    <td id="ajax_woi_height"><? echo elphel_get_P_value(ELPHEL_WOI_HEIGHT); ?></td>
                    <td><input type="checkbox" name="binning_ver" id="binning_ver" /></td>
                    <td><b>Y:</b> </td>
                    <td id="ajax_binning_ver"><? echo "1:".elphel_get_P_value(ELPHEL_BIN_VERT); ?></td>
                    <td><input type="checkbox" name="dec_ver" id="dec_ver" /></td>
                    <td><b>Y:</b> </td>
                    <td id="ajax_dec_ver"><? echo "1:".elphel_get_P_value(ELPHEL_DCM_VERT); ?></td>
                </tr>
            </table>
            <p class="smalldivider"></p>
            <table class="parameter_table" border="0px" cellpadding="0px" cellspacing="0px">
                <tr><td colspan="3">Image Settings:</td></tr>
                <tr>
                	<td><input type="checkbox" name="mirror" id="mirror" /></td>
                    <td><b>Mirror:</b> </td>
                    <td id="ajax_mirror">
						<? 
						$flip_h = elphel_get_P_value(ELPHEL_FLIPH);
						$flip_v = elphel_get_P_value(ELPHEL_FLIPV);
						if($flip_h && $flip_v)
							echo "X &amp; Y";
						if(!$flip_h && $flip_v)
							echo "Y";
						if($flip_h && !$flip_v)							
							echo "X";
						if(!$flip_h && !$flip_v)
							echo "off";
                        ?>
                    </td>
                	<td><input type="checkbox" name="color" id="color" /></td>
                    <td><b>Color Mode:</b> </td>
					<td id="ajax_color">
						<?
						echo elphel_get_P_value(ELPHEL_BITS)."bit ";
                        switch (elphel_get_P_value(ELPHEL_COLOR))
                        {
                            case 0:
                                echo "b/w";
                                break;
                            case 1:
                                echo "color";
                                break;
                            case 2:
                                echo "JP4";
                                break;
                            default :
                                echo "Bars";
                                break;
                        }?>                    </td>
                	<td><input type="checkbox" name="jpeg_qual" id="jpeg_qual" /></td>
                    <td><b>JPEG Qual.:</b> </td>
                    <td width="30px" id="ajax_jpeg_qual"><? echo elphel_get_P_value(ELPHEL_QUALITY)." %"; ?></td>
                </tr>
            </table>
            <p class="smalldivider"></p>
            <table class="parameter_table" border="0px" cellpadding="0px" cellspacing="0px">
                <tr><td colspan="12">Analog Gain:</td></tr>
                <td><input type="checkbox" name="analog_gain" id="analog_gain" /></td>
                    <td><b>Gain:</b> </td>
                    <td id="ajax_analog_gain"><? echo 10*round(log(elphel_get_P_value(ELPHEL_GAING)/65536, 10),2) ." dB"; ?></td>          
                	<tr>
                	<td><input type="checkbox" name="gain_r" id="gain_r" /></td>
                    <td><b>R:</b> </td>
                    <td id="ajax_gain_r"><? echo elphel_get_P_value(ELPHEL_GAINR)/65536*100 ." %"; ?></td>
                	<td><input type="checkbox" name="gain_g" id="gain_g" /></td>
                    <td><b>G:</b> </td>
                    <td id="ajax_gain_g"><? echo elphel_get_P_value(ELPHEL_GAING)/65536*100 ." %"; ?></td>
                	<td><input type="checkbox" name="gain_b" id="gain_b" /></td>
                    <td><b>B:</b> </td>
                    <td id="ajax_gain_b"><? echo elphel_get_P_value(ELPHEL_GAINB)/65536*100 ." %"; ?></td>                    
                	<td><input type="checkbox" name="gain_gb" id="gain_gb" /></td>
                    <td><b>GB:</b> </td>
                    <td id="ajax_gain_gb"><? echo elphel_get_P_value(ELPHEL_GAINGB)/65536*100 ." %"; ?></td>
                    </tr>
             </table>
             <p class="smalldivider"></p>
             <table class="parameter_table" border="0px" cellpadding="0px" cellspacing="0px">
                 <tr><td colspan="9">Color Scaling:</td></tr>
                 <tr>
					<td><input type="checkbox" name="scale_r" id="scale_r" /></td>
                    <td><b>R:</b> </td>
                    <td id="ajax_scale_r"><? echo round(elphel_get_P_value(ELPHEL_RSCALE)/256*100, 0)." %"; ?></td>
                    <td><input type="checkbox" name="scale_g" id="scale_g" /></td>
                    <td><b>G:</b> </td>
                    <td id="ajax_scale_g"><? echo round(elphel_get_P_value(ELPHEL_GSCALE)/256*100, 0)." %"; ?></td>
                    <td><input type="checkbox" name="scale_b" id="scale_b" /></td>
                    <td><b>B:</b> </td>
                    <td id="ajax_scale_b"><? echo round(elphel_get_P_value(ELPHEL_BSCALE)/256*100, 0)." %"; ?></td>
                </tr>
                </table>
            <p class="smalldivider"></p>
			<table class="parameter_table" border="0px" cellpadding="0px" cellspacing="0px">
            	<tr><td colspan="9">Saturation:</td></tr>
				<tr>
					<td><input type="checkbox" name="sat_r" id="sat_r" /></td>
                    <td><b>R:</b> </td>
                    <td id="ajax_sat_r"><? echo elphel_get_P_value(ELPHEL_COLOR_SATURATION_RED); ?></td>
                    <td><input type="checkbox" name="sat_b" id="sat_b" /></td>
                    <td><b>B:</b> </td>
                    <td id="ajax_sat_b"><? echo elphel_get_P_value(ELPHEL_COLOR_SATURATION_BLUE); ?></td>             
                </tr>
            </table>
            <p class="smalldivider"></p>
            <table class="parameter_table" border="0px" cellpadding="0px" cellspacing="0px">
            	<tr>
                	<td><input type="checkbox" name="gamma" id="gamma" /></td>
                    <td><b>Gamma:</b> </td>
                    <td id="ajax_gamma"><? echo elphel_get_P_value(ELPHEL_GAMMA)/100; ?></td>
                	<td><input type="checkbox" name="black_level" id="black_level" /></td>
                    <td><b>Black Level:</b> </td>
                    <td id="ajax_black_level"><? echo elphel_get_P_value(ELPHEL_PIXEL_LOW); ?></td>
                	<td><input type="checkbox" name="white_level" id="white_level" /></td>
                    <td><b>White Level:</b> </td>
					<td id="ajax_white_level"><? echo elphel_get_P_value(ELPHEL_PIXEL_HIGH); ?></td>                   
                </tr>
                </table>
                <table class="parameter_table" border="0px" cellpadding="0px" cellspacing="0px">
				<tr>
					<td><input type="checkbox" name="exposure" id="exposure"  /></td>
                    <td><b>Exposure:</b> </td>
                    <td id="ajax_exposure"><? echo elphel_get_P_value(ELPHEL_EXPOS)/1000 ." ms"; ?></td>
                    <td><input type="checkbox" name="fps" id="fps" /></td>
                    <td><b>FPS:</b> </td>
                    <td id="ajax_fps"><? echo elphel_get_P_value(ELPHEL_FP1000S)/1000; ?></td>   
                </tr>
            </table>
            <input type="button" value="Select All" name="sel_all" onClick="sel_all();"> <input type="button" value="Select None" name="sel_none"  onClick="sel_none();"><br>
            <br>
            <table>
            <tr><td>Preset Name:</td><td><input class="field" type="text" name="preset_name" id="preset_name" ></td></tr>
            <tr><td>Description:</td><td><textarea name="preset_desc" rows="2" class="field" id="preset_desc"></textarea></td></tr>
            <tr><td></td><td><input type="button" value="Save" name="save" onClick="save_preset();"></td></tr>
            </table>
            </div>
            <div class="TabbedPanelsContent">
            <!-- Auto Save -->
            </div>
            <div class="TabbedPanelsContent">
	            <!-- Sound -->
            </div>
            <div class="TabbedPanelsContent">
            <!-- Advanced -->
            </div>        
          </div>
    	</div>        </td>
        </table>
    </div>
	<script type="text/javascript">
	<!--
	if (getCookie('live_image_panel_open') == "true")
		var CollapsiblePanel1 = new Spry.Widget.CollapsiblePanel("CollapsiblePanel1", {contentIsOpen:true});
	else
		var CollapsiblePanel1 = new Spry.Widget.CollapsiblePanel("CollapsiblePanel1", {contentIsOpen:false});
		
	var TabbedPanels1 = new Spry.Widget.TabbedPanels("TabbedPanels1");

	if (getCookie('preset_tab') != "")
		TabbedPanels1.showPanel(parseInt(getCookie('preset_tab')));
	//-->
	</script>
</body>

